package com.offcn.api.xyzb;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MyDateUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.BasicsGM;
import com.offcn.process.XYZB;

import net.sf.json.JSONObject;



/**
 * 添加问题
 * 
 * @author puhui
 *
 */
public class questions extends XYZB implements API {
	public String parameter;//参数集合
	
	public String name;//问题内容
	public String room_id;//房间名称
	public String user_id;//房间用户id

	@Override
	public void initialize(HashMap<String, Object> data) {
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		user_id=Current_user_id;
		parameter = MapUtil.getValue("parameter", data);
		name = MapUtil.getParameter(parameter, "name").trim();
		if(Current_password.contains("Not_started")){
			room_id=ReadProperties.GetinformationByKey("Not_started_xyzbid");
		}else if(Current_password.contains("Running_xyzb")){
			room_id=ReadProperties.GetinformationByKey("Running_xyzbid");
		}else if(Current_password.contains("Finished_xyzb")){
			room_id=ReadProperties.GetinformationByKey("Finished_xyzbid");
		}else if(Current_password.contains("Invalid_xyzb")){
			room_id=ReadProperties.GetinformationByKey("Invalid_xyzbid");
		}else if(Current_password.contains("Not_edited_xyzb")){
			room_id=ReadProperties.GetinformationByKey("Not_edited_xyzbid");
		}
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		Response re = RequestDataUtils.Post_token(data, Url,Client_token);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=StringUtils.decodeUnicode(jp.getString("msg"));
			
			if ((data.get("code") != null )
					&& ((jp.getString("code") == null) || (!jp.getString(
							"code").equals(data.get("code").toString())))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null)
					&& ((msg == null) || (!msg.equals(data.get("msg").toString())))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			if("操作成功".equals(jp.getString("msg"))){
				
				//是否是线上环境
				if (!isProduct) {
					
					try {
						ResultSet rs_bankcard = this.selectFromDB(
								" xyu_room_question  ",
								" 1 = 1");
						rs_bankcard.last();
						
						if (rs_bankcard.getRow() < 1) {
							result = result && false;
							failReason = failReason + "xyu_room_question info is not in DB;";
						} else {
							
							String act_room_id = String
									.valueOf(rs_bankcard.getString(rs_bankcard.findColumn("room_id")));
							String act_name = String
									.valueOf(rs_bankcard.getString(rs_bankcard.findColumn("name")));
							String act_user_id = String
									.valueOf(rs_bankcard.getString(rs_bankcard.findColumn("user_id")));
							
							Current_questions_id=String
									.valueOf(rs_bankcard.getString(rs_bankcard.findColumn("id")));
//							System.out.println(name);
//							System.out.println(StringUtils.decodeUnicode(act_name));
							if ((!room_id.equals(act_room_id))
									|| (!name.equals(StringUtils.decodeUnicode(act_name)))
									|| (!user_id.equals(act_user_id))){
								result = result && false;
								failReason = failReason + "xyu_room_question info in DB is wrong;";
							} 
						}
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify xyu_room_question info in DB;";
						e.printStackTrace();
					}
				}
			}
			
			
		}
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
